package useful

import (
	"strings"

	"tuxpa.in/a/irc/pkg/ircv3"
)

type Autojoin struct {
	Channels []string
}

func (u *Autojoin) Middleware(next ircv3.Handler) ircv3.Handler {
	return ircv3.HandlerFunc(func(w ircv3.MessageWriter, e *ircv3.Event) {
		if e.Msg.Command == "005" {
			w.WriteMessage(ircv3.NewMessage("JOIN", strings.Join(u.Channels, ",")))
		}
		next.Handle(w, e)
	})
}
